
/*
 * claim.c
 *
 * Code to construct a Meiko svcs proc/wire claim structure from
 * arguments passed to a program.
 *
 * (C) David Beckett 1991 University of Kent at Canterbury
 */

/* **********************************************************************
 * claim
 * Claim the given processors in the list of matches.
 * **********************************************************************
 */

struct DomainSpec *
claim(/* matches, wires, wait, vcsfd, supfd*/);

/* **********************************************************************
 * free_claim
 * Free the earlier claim for processors in the list of matches.
 * **********************************************************************
 */

void
free_claim(/* struct DomainSpec *d */);

/* **********************************************************************
 * get_wire
 * Parse the wire specification
 * Set munge=TRUE to add 1 to all proc. numbers to account for the 
 * intermediate buffer processor.
 * **********************************************************************
 */

BOOL
get_wire(/* char *arg, List *wires, BOOL munge */ );

