
/*
 --   ---------------------------------------------------------------------------
 --
 --      ISERVER  -  INMOS standard file server
 --
 --      meikosub.c
 --
 --      Subsystem module for Meiko boards with /dev/mpn device driver
 --
 --      Copyright (c) H7 1991.
 --      All Rights Reserved.
 --
 --   ---------------------------------------------------------------------------
*/

#include <stdio.h>
#include <svcs.h>
#include "inmos.h"
#include "iserver.h"
#include "supercmd.h"

EXTERN LINK TheLink;
EXTERN int vcsfd, supfd, CocoPops;
EXTERN BOOL VerboseSwitch;
EXTERN Resources theResources;

PRIVATE int ResetProcessor( supv_busid  )
int supv_busid;
{
  if (writeReset(supfd, supv_busid, 1)) return 0;
  if (writeReset(supfd, supv_busid, 0)) return 0;
  else return 1;
}

PRIVATE int AnalyseProcessor( supv_busid  )
int supv_busid;
{
  INFO(("Analyzing processor no %d \n",supv_busid));
  if (writeAnalyse(supfd, supv_busid, 1)) return 0;
  { int i=0;
    for (;i<100000;i++); /* wait a while */
  }
  if (writeReset(supfd, supv_busid, 1)) return 0;
  { int i=0;
    for (;i<100000;i++); /* wait a while */
  }
  if (writeReset(supfd, supv_busid, 0)) return 0;
  { int i=0;
    for (;i<100000;i++); /* wait a while */
  }
  if (writeAnalyse(supfd, supv_busid, 0)) return 0;
  else return 1;
}


PRIVATE int MkReset(/* void */)
{ int procNo;

  for (procNo = 2; procNo < theResources.r_nprocs ; procNo++ ) {
      if(!ResetProcessor(procNo)) return (1);
  }
  return(0);
}

PRIVATE int MkAnalyse(/* void */)
{ int procNo;
  INFO(("Subsystem analyse for %d Procs\n",theResources.r_nprocs));

  for (procNo = 2; procNo < theResources.r_nprocs ; procNo++ ) {
      if (!AnalyseProcessor(procNo)) return (1);
  }
  return(0);
}

PUBLIC VOID AnalyseSubsystem(TheLink)
LINK TheLink;
{

  if (MkAnalyse() != 0) {
    ABORT(MISC_EXIT,(SE,"Error analysing subsystem"));
  }
}

PUBLIC VOID ResetSubsystem(TheLink)
LINK TheLink;
{

  if (MkReset() != 0) {
    ABORT(MISC_EXIT,(SE,"Error resetting subsystem"));
  }
}


/*
 *  Eof
 */
