
/*
 --   ---------------------------------------------------------------------------
 --
 --      ISERVER  -  INMOS standard file server
 --
 --      tds.c
 --
 --      tds specific iserver extensions
 --
 --      Copyright (c) INMOS Ltd., 1988.
 --      All Rights Reserved.
 --
 --   ---------------------------------------------------------------------------
*/

#include <stdio.h>
#include "inmos.h"
#include "iserver.h"
#include "pack.h"

EXTERN LINK TheLink;
EXTERN int vcsfd, supfd, CocoPops;
EXTERN BOOL VerboseSwitch;
EXTERN BYTE Tbuf[TRANSACTION_BUFFER_SIZE];


#define SS_RESET 		1
#define SS_ANALYSE_NOT_RESET 	2
#define SS_ERROR 		4

EXTERN VOID ResetSubsystem(/* TheLink */);
EXTERN VOID AnalyseSubsystem(/* TheLink */);

PUBLIC VOID SpTDS()
{
   BUFFER_DECLARATIONS;
   BYTE tds_tag;
   INT32 request;

   DEBUG(( "SP.TDS" ));
   DEBUG(("[Encountered TDS primary tag (%d)]\n", Tbuf[2]));
   INIT_BUFFERS;
   GET_BYTE( tds_tag );
   DEBUG(("[Encountered TDS secondary tag (%d)]\n", Tbuf[3]));
   GET_INT32 (request);
   DEBUG(("[TDS secondary request was (%d)]\n", request));
   switch(request) {
     case SS_ANALYSE_NOT_RESET: {
          INFO(( "SP.subsystem.analyse" ));
          AnalyseSubsystem(TheLink) ; 
          PUT_BYTE( SP_SUCCESS );
          break;
          }
     case SS_RESET: {
          DEBUG(( "SP.subsystem.reset" ));
          ResetSubsystem(TheLink) ; 
          PUT_BYTE( SP_SUCCESS );
          break;
          }
     case SS_ERROR: {
          DEBUG(( "SP.subsystem.errorstatus.request" ));
          PUT_BYTE( SP_SUCCESS );
          break;
          }
     default: PUT_BYTE( SP_UNIMPLEMENTED );
   }
   PUT_COUNT( OutCount );
}

/*
 *  eof
 */

